Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2241171 - Review Request: python-pyxdameraulevenshtein - Damerau-Levenshtein (DL) edit distance algorithm
Summary: Review Request: python-pyxdameraulevenshtein - Damerau-Levenshtein (DL) edit ...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Benson Muite
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro, NeuroFedora
TreeView+ depends on / blocked
 
Reported: 2023-09-28 11:17 UTC by Ben Beasley
Modified: 2023-11-03 18:26 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2023-10-01 14:31:43 UTC
Type: Bug
Embargoed:
benson_muite: fedora-review+


Attachments (Terms of Use)

Description Ben Beasley 2023-09-28 11:17:18 UTC
Spec URL: https://music.fedorapeople.org/python-pyxdameraulevenshtein.spec
SRPM URL: https://music.fedorapeople.org/python-pyxdameraulevenshtein-1.7.1-1.fc40.src.rpm

Description:

pyxDamerauLevenshtein implements the Damerau-Levenshtein (DL) edit distance
algorithm for Python in Cython for high performance.

Fedora Account System Username: music

Koji scratch builds:

F40: https://koji.fedoraproject.org/koji/taskinfo?taskID=106793170
F39: https://koji.fedoraproject.org/koji/taskinfo?taskID=106793441
F38: https://koji.fedoraproject.org/koji/taskinfo?taskID=106793607
F37: https://koji.fedoraproject.org/koji/taskinfo?taskID=106793824

Of the three missing optional dependencies that would enable additional functionality in python-textdistance, this is the one that is actively maintained. Once python-textdistance upstream follows through with removing the abydos dependency (https://github.com/life4/textdistance/pull/90), having this packaged will allow us to add metapackages for several textdistance extras.

This will be a neuro-sig package.

Comment 1 Benson Muite 2023-10-01 13:44:42 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-Clause License", "*No copyright*
     BSD 3-Clause License". 7 files have unknown license. Detailed output
     of licensecheck in
     /home/FedoraPackaging/reviews/python-pyxdameraulevenshtein/2241171-
     python-pyxdameraulevenshtein/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 19200 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[-]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-pyxdameraulevenshtein
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: python3-pyxdameraulevenshtein-1.7.1-1.fc38.x86_64.rpm
          python-pyxdameraulevenshtein-debugsource-1.7.1-1.fc38.x86_64.rpm
          python-pyxdameraulevenshtein-1.7.1-1.fc38.src.rpm
=================================== rpmlint session starts ==================================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpa1ead3zc')]
checks: 31, packages: 3

python3-pyxdameraulevenshtein.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/python3-pyxdameraulevenshtein/CHANGES.md
python-pyxdameraulevenshtein.src: W: strange-permission python-pyxdameraulevenshtein.spec 600
==== 3 packages and 0 specfiles checked; 0 errors, 2 warnings, 0 badness; has taken 5.7 s ===




Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 2

python3-pyxdameraulevenshtein.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/python3-pyxdameraulevenshtein/CHANGES.md
 2 packages and 0 specfiles checked; 0 errors, 1 warnings, 0 badness; has taken 1.0 s 



Unversioned so-files
--------------------
python3-pyxdameraulevenshtein: /usr/lib64/python3.11/site-packages/pyxdameraulevenshtein.cpython-311-x86_64-linux-gnu.so

Source checksums
----------------
https://github.com/lanl/pyxDamerauLevenshtein/archive/v1.7.1/pyxDamerauLevenshtein-1.7.1.tar.gz :
  CHECKSUM(SHA256) this package     : e2bd561d97dc5441772379826d665fa8b2bffc2e0180da03b2b29b48f38b97d5
  CHECKSUM(SHA256) upstream package : e2bd561d97dc5441772379826d665fa8b2bffc2e0180da03b2b29b48f38b97d5


Requires
--------
python3-pyxdameraulevenshtein (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    python(abi)
    rtld(GNU_HASH)

python-pyxdameraulevenshtein-debugsource (rpmlib, GLIBC filtered):



Provides
--------
python3-pyxdameraulevenshtein:
    python-pyxdameraulevenshtein
    python3-pyxdameraulevenshtein
    python3-pyxdameraulevenshtein(x86-64)
    python3.11-pyxdameraulevenshtein
    python3.11dist(pyxdameraulevenshtein)
    python3dist(pyxdameraulevenshtein)

python-pyxdameraulevenshtein-debugsource:
    python-pyxdameraulevenshtein-debugsource
    python-pyxdameraulevenshtein-debugsource(x86-64)



Diff spec file in url and in SRPM
---------------------------------
--- /home/FedoraPackaging/reviews/python-pyxdameraulevenshtein/2241171-python-pyxdameraulevenshtein/srpm/python-pyxdameraulevenshtein.spec   2023-09-28 20:46:02.695568432 +0300
+++ /home/FedoraPackaging/reviews/python-pyxdameraulevenshtein/2241171-python-pyxdameraulevenshtein/srpm-unpacked/python-pyxdameraulevenshtein.spec  2023-09-27 03:00:00.000000000 +0300
@@ -1,2 +1,12 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.3.5)
+## RPMAUTOSPEC: autorelease, autochangelog
+%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
+    release_number = 1;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
+## END: Set by rpmautospec
+
 Name:           python-pyxdameraulevenshtein
 Version:        1.7.1
@@ -68,3 +78,4 @@
 
 %changelog
-%autochangelog
+* Wed Sep 27 2023 John Doe <packager> - 1.7.1-1
+- Uncommitted changes


Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2241171 -m fedora-38-x86_64
Buildroot used: fedora-38-x86_64
Active plugins: Shell-api, Generic, Python
Disabled plugins: C/C++, R, Ruby, fonts, PHP, Haskell, Ocaml, Java, Perl, SugarActivity
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comments:
a) Perhaps change permissions of spec file and line end encoding of CHANGES.md upon import.
b) Approved
c) May wish to also examine https://pypi.org/project/editdistance/

Comment 2 Ben Beasley 2023-10-01 14:14:24 UTC
Thank you for the review!

(In reply to Benson Muite from comment #1)
> Comments:
> a) Perhaps change permissions of spec file and line end encoding of
> CHANGES.md upon import.

The warning

  python-pyxdameraulevenshtein.src: W: strange-permission python-pyxdameraulevenshtein.spec 600

is an rpmautospec bug that appears on every package that uses it. It looks like it was fixed, but the fix was not yet released. See https://pagure.io/fedora-infra/rpmautospec/issue/301 for details. Fortunately, the “strange” permissions are harmless.

The “DOS-style” CRLF line terminators in CHANGES.md are indeed something I missed, and I will fix them on import.

> b) Approved
> c) May wish to also examine https://pypi.org/project/editdistance/

There are a lot of implementations of this family of algorithms. The goal of packaging this one is to provide all of the optional dependencies of https://src.fedoraproject.org/rpms/python-textdistance, which in turn is a dependency for the Spyder IDE. We don’t strictly need the corresponding textdistance “extras” for Spyder, but it’s nice to have a complete package.

Comment 3 Fedora Admin user for bugzilla script actions 2023-10-01 14:15:04 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/python-pyxdameraulevenshtein

Comment 4 Ben Beasley 2023-10-01 14:21:16 UTC
Added to release monitoring: https://release-monitoring.org/project/98256/

Comment 5 Fedora Update System 2023-10-01 14:30:37 UTC
FEDORA-2023-285a34969f has been submitted as an update to Fedora 40. https://bodhi.fedoraproject.org/updates/FEDORA-2023-285a34969f

Comment 6 Fedora Update System 2023-10-01 14:31:43 UTC
FEDORA-2023-285a34969f has been pushed to the Fedora 40 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 7 Fedora Update System 2023-10-01 22:19:03 UTC
FEDORA-2023-c5860ebb98 has been submitted as an update to Fedora 39. https://bodhi.fedoraproject.org/updates/FEDORA-2023-c5860ebb98

Comment 8 Fedora Update System 2023-10-01 22:31:53 UTC
FEDORA-2023-35277dfd23 has been submitted as an update to Fedora 38. https://bodhi.fedoraproject.org/updates/FEDORA-2023-35277dfd23

Comment 9 Fedora Update System 2023-10-02 02:51:30 UTC
FEDORA-2023-c5860ebb98 has been pushed to the Fedora 39 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-c5860ebb98`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-c5860ebb98

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2023-10-02 03:34:48 UTC
FEDORA-2023-35277dfd23 has been pushed to the Fedora 38 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-35277dfd23`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-35277dfd23

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2023-10-02 11:29:13 UTC
FEDORA-EPEL-2023-5eab24e5f1 has been submitted as an update to Fedora EPEL 9. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2023-5eab24e5f1

Comment 12 Fedora Update System 2023-10-02 11:44:11 UTC
FEDORA-2023-1a861aaba5 has been submitted as an update to Fedora 37. https://bodhi.fedoraproject.org/updates/FEDORA-2023-1a861aaba5

Comment 13 Fedora Update System 2023-10-03 02:09:21 UTC
FEDORA-2023-1a861aaba5 has been pushed to the Fedora 37 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-1a861aaba5`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-1a861aaba5

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2023-10-03 02:30:23 UTC
FEDORA-EPEL-2023-5eab24e5f1 has been pushed to the Fedora EPEL 9 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2023-5eab24e5f1

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2023-10-10 01:36:03 UTC
FEDORA-2023-35277dfd23 has been pushed to the Fedora 38 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 16 Fedora Update System 2023-10-11 00:38:48 UTC
FEDORA-EPEL-2023-5eab24e5f1 has been pushed to the Fedora EPEL 9 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 17 Fedora Update System 2023-10-11 01:33:31 UTC
FEDORA-2023-1a861aaba5 has been pushed to the Fedora 37 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 18 Fedora Update System 2023-11-03 18:26:04 UTC
FEDORA-2023-c5860ebb98 has been pushed to the Fedora 39 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.